/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.32 Revision 1.122
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.32 2009/03/11 17:40:51 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.122 2013/02/02 16:58:00 dilfridge Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# eclass will fail with version older than 2. 14# over time as new EAPI versions are approved.
15 15
16inherit base cmake-utils eutils kde4-functions 16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
17 22
18get_build_type 23# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
24# @DESCRIPTION:
25# If defined, launch and use a private dbus session during src_test.
26
27# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
28# @DESCRIPTION:
29# For proper description see virtualx.eclass manpage.
30# Here we redefine default value to be manual, if your package needs virtualx
31# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
32: ${VIRTUALX_REQUIRED:=manual}
33
34inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils base virtualx versionator eutils multilib
35
19if [[ ${BUILD_TYPE} = live ]]; then 36if [[ ${KDE_BUILD_TYPE} = live ]]; then
37 case ${KDE_SCM} in
20 inherit subversion 38 svn) inherit subversion ;;
39 git) inherit git-2 ;;
40 esac
21fi 41fi
22 42
23EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 43# @ECLASS-VARIABLE: CMAKE_REQUIRED
44# @DESCRIPTION:
45# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
46# Please note that if it's set to 'never' you need to explicitly override following phases:
47# src_configure, src_compile, src_test and src_install.
48# Defaults to 'always'.
49: ${CMAKE_REQUIRED:=always}
50if [[ ${CMAKE_REQUIRED} = always ]]; then
51 buildsystem_eclass="cmake-utils"
52 export_fns="src_configure src_compile src_test src_install"
53fi
24 54
25# @FUNCTION: kde4-base_set_qt_dependencies 55# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements.
60# Note that it is fixed to ${PV} for kde-base packages.
61KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
62
63# Set slot for KDEBASE known packages
64case ${KDEBASE} in
65 kde-base)
66 SLOT=4
67 KDE_MINIMAL="${PV}"
68 ;;
69 kdevelop)
70 if [[ ${KDE_BUILD_TYPE} = live ]]; then
71 # @ECLASS-VARIABLE: KDEVELOP_VERSION
26# @DESCRIPTION: 72 # @DESCRIPTION:
27# Set qt dependencies. And use opengl based on OPENGL_REQUIRED variable. 73 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
28kde4-base_set_qt_dependencies() { 74 # Applies to KDEBASE=kdevelop only.
29 local qtdepend qtopengldepend 75 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
76 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
77 # @DESCRIPTION:
78 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
79 # Applies to KDEBASE=kdevelop only.
80 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
81 else
82 case ${PN} in
83 kdevelop|quanta)
84 KDEVELOP_VERSION=${PV}
85 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
86 ;;
87 kdevplatform|kdevelop-php*)
88 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
89 KDEVPLATFORM_VERSION=${PV}
90 ;;
91 *)
92 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
93 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
94 esac
95 fi
96 SLOT="4"
97 ;;
98esac
30 99
100inherit ${buildsystem_eclass}
101
102EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
103
104unset buildsystem_eclass
105unset export_fns
106
107# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
108# @DESCRIPTION:
109# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
110# This variable must be set before inheriting any eclasses. Defaults to 'never'.
111DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
112
113# @ECLASS-VARIABLE: QTHELP_REQUIRED
114# @DESCRIPTION:
115# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
116# This variable must be set before inheriting any eclasses. Defaults to 'never'.
117QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
118
119# @ECLASS-VARIABLE: OPENGL_REQUIRED
120# @DESCRIPTION:
121# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
122# This variable must be set before inheriting any eclasses. Defaults to 'never'.
123OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
124
125# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
126# @DESCRIPTION:
127# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
128# This variable must be set before inheriting any eclasses. Defaults to 'never'.
129MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
130
131# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
132# @DESCRIPTION:
133# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
134# This variable must be set before inheriting any eclasses. Defaults to 'never'.
135CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
136
137# @ECLASS-VARIABLE: KDE_REQUIRED
138# @DESCRIPTION:
139# Is kde required? Possible values are 'always', 'optional' and 'never'.
140# This variable must be set before inheriting any eclasses. Defaults to 'always'
141# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
142# Note that for kde-base packages this variable is fixed to 'always'.
143KDE_REQUIRED="${KDE_REQUIRED:-always}"
144
145# @ECLASS-VARIABLE: KDE_HANDBOOK
146# @DESCRIPTION:
147# Set to enable handbook in application. Possible values are 'always', 'optional'
148# (handbook USE flag) and 'never'.
149# This variable must be set before inheriting any eclasses. Defaults to 'never'.
150# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
151# ensures buildtime and runtime dependencies.
152KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
153
154# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
155# @DESCRIPTION:
156# Set this varible if you want your live package to manage its
157# translations. (Mostly all kde ebuilds does not ship documentation
158# and translations in live ebuilds)
159if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
160 # Kdebase actualy provides the handbooks even for live stuff
161 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
162 KDE_LINGUAS=""
163fi
164
165# Setup packages inheriting this eclass
166case ${KDEBASE} in
167 kde-base)
168 HOMEPAGE="http://www.kde.org/"
169 LICENSE="GPL-2"
170 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
171 # Disable tests for live ebuilds by default
172 RESTRICT+=" test"
173 fi
174
175 # This code is to prevent portage from searching GENTOO_MIRRORS for
176 # packages that will never be mirrored. (As they only will ever be in
177 # the overlay).
178 case ${PV} in
179 *9999* | 4.?.[6-9]?)
180 RESTRICT+=" mirror"
181 ;;
182 esac
183 ;;
184 kdevelop)
185 HOMEPAGE="http://www.kdevelop.org/"
186 LICENSE="GPL-2"
187 ;;
188esac
189
190# @ECLASS-VARIABLE: QT_MINIMAL
191# @DESCRIPTION:
192# Determine version of qt we enforce as minimal for the package.
193if version_is_at_least 4.8.50 "${KDE_MINIMAL}"; then
194 # Upstream has added an *undeclared* dependency on Qt 4.8...
195 QT_MINIMAL="${QT_MINIMAL:-4.8.0}"
196else
197 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
198fi
199
200# Declarative dependencies
201qtdeclarativedepend="
202 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
203"
204case ${DECLARATIVE_REQUIRED} in
205 always)
206 COMMONDEPEND+=" ${qtdeclarativedepend}"
207 ;;
208 optional)
209 IUSE+=" declarative"
210 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
211 ;;
212 *) ;;
213esac
214unset qtdeclarativedepend
215
216# QtHelp dependencies
31 qtdepend=" 217qthelpdepend="
32 x11-libs/qt-core:4[qt3support,ssl] 218 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
33 x11-libs/qt-gui:4[accessibility,dbus] 219"
34 x11-libs/qt-qt3support:4[accessibility] 220case ${QTHELP_REQUIRED} in
35 x11-libs/qt-script:4 221 always)
36 x11-libs/qt-sql:4[qt3support] 222 COMMONDEPEND+=" ${qthelpdepend}"
37 x11-libs/qt-svg:4 223 ;;
38 x11-libs/qt-test:4 224 optional)
39 " 225 IUSE+=" qthelp"
40 qtwebkitdepend=" 226 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
41 x11-libs/qt-webkit:4 227 ;;
42 " 228esac
229unset qthelpdepend
230
231# OpenGL dependencies
43 qtopengldepend=" 232qtopengldepend="
44 x11-libs/qt-opengl:4 233 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
45 " 234"
46
47 case ${WEBKIT_REQUIRED} in
48 always)
49 qtdepend="${qtdepend}
50 ${qtwebkitdepend}"
51 ;;
52 optional)
53 IUSE="${IUSE} webkit"
54 qtdepend="${qtdepend}
55 webkit? ( ${qtwebkitdepend} )
56 "
57 ;;
58 *) WEBKIT_REQUIRED="never" ;;
59 esac
60 # opengl dependencies
61 case ${OPENGL_REQUIRED} in 235case ${OPENGL_REQUIRED} in
62 always) 236 always)
63 qtdepend="${qtdepend} 237 COMMONDEPEND+=" ${qtopengldepend}"
64 ${qtopengldepend}
65 "
66 ;; 238 ;;
67 optional) 239 optional)
68 IUSE="${IUSE} opengl" 240 IUSE+=" opengl"
69 qtdepend="${qtdepend}
70 opengl? ( ${qtopengldepend} ) 241 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
71 "
72 ;; 242 ;;
73 *) OPENGL_REQUIRED="never" ;; 243 *) ;;
74 esac 244esac
245unset qtopengldepend
75 246
76 COMMONDEPEND="${COMMONDEPEND} ${qtdepend}" 247# MultiMedia dependencies
77} 248qtmultimediadepend="
249 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
250"
251case ${MULTIMEDIA_REQUIRED} in
252 always)
253 COMMONDEPEND+=" ${qtmultimediadepend}"
254 ;;
255 optional)
256 IUSE+=" multimedia"
257 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
258 ;;
259 *) ;;
260esac
261unset qtmultimediadepend
78 262
79if [[ ${NEED_KDE} != "none" ]] ; then 263# CppUnit dependencies
80 # Qt 264cppuintdepend="
81 kde4-base_set_qt_dependencies 265 dev-util/cppunit
266"
267case ${CPPUNIT_REQUIRED} in
268 always)
269 DEPEND+=" ${cppuintdepend}"
270 ;;
271 optional)
272 IUSE+=" test"
273 DEPEND+=" test? ( ${cppuintdepend} )"
274 ;;
275 *) ;;
276esac
277unset cppuintdepend
82 278
83 # Xorg 279# KDE dependencies
84 COMMONDEPEND="${COMMONDEPEND} 280# Qt accessibility classes are needed in various places, bug 325461
85 >=x11-base/xorg-server-1.5.2 281kdecommondepend="
86 " 282 dev-lang/perl
87 283 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
88 # X11 libs 284 >=x11-libs/qt-dbus-${QT_MINIMAL}:4
89 COMMONDEPEND="${COMMONDEPEND} 285 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
286 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility]
287 >=x11-libs/qt-script-${QT_MINIMAL}:4
288 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
289 >=x11-libs/qt-svg-${QT_MINIMAL}:4
290 >=x11-libs/qt-test-${QT_MINIMAL}:4
291 >=x11-libs/qt-webkit-${QT_MINIMAL}:4
292 !aqua? (
90 x11-libs/libXext 293 x11-libs/libXext
91 x11-libs/libXt 294 x11-libs/libXt
92 x11-libs/libXxf86vm 295 x11-libs/libXxf86vm
93 " 296 x11-libs/libXcomposite
297 x11-libs/libxkbfile
298 )
299"
94 300
95 # localization deps 301if [[ ${PN} != kdelibs ]]; then
96 # DISABLED UNTIL PMS decide correct approach :( 302 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
97 if [[ -n ${KDE_LINGUAS} ]]; then 303 if [[ ${KDEBASE} = kdevelop ]]; then
98 LNG_DEP="" 304 if [[ ${PN} != kdevplatform ]]; then
99 for _lng in ${KDE_LINGUAS}; do 305 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
100 # there must be or due to issue if lingua is not present in kde-l10n so 306 # @DESCRIPTION:
101 # it wont die but pick kde-l10n as-is. 307 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
102 LNG_DEP="${LNG_DEP} 308 # Applies to KDEBASE=kdevelop only.
103 || ( kde-base/kde-l10n[linguas_${_lng},kdeprefix=] kde-base/kde-l10n[kdeprefix=] )" 309 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
104 done 310 case ${KDEVPLATFORM_REQUIRED} in
311 always)
312 kdecommondepend+="
313 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
314 "
315 ;;
316 *) ;;
317 esac
105 fi 318 fi
106 319 fi
107 # Set common dependencies for all ebuilds that inherit this eclass
108 DEPEND="${DEPEND} ${COMMONDEPEND}
109 >=dev-util/cmake-2.6.2
110 dev-util/pkgconfig
111 >=sys-apps/sandbox-1.3.2
112 "
113 RDEPEND="${RDEPEND} ${COMMONDEPEND}"
114fi # NEED_KDE != NONE block
115
116if [[ $BUILD_TYPE = live ]]; then
117 # Disable tests for live ebuilds
118 RESTRICT="${RESTRICT} test"
119 # Live ebuilds in kde-base default to kdeprefix by default
120 IUSE="${IUSE} +kdeprefix"
121else
122 # All other ebuild types default to -kdeprefix as before
123 IUSE="${IUSE} kdeprefix"
124fi 320fi
125 321
126# @ECLASS-VARIABLE: OPENGL_REQUIRED 322kdedepend="
127# @DESCRIPTION: 323 dev-util/automoc
128# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 324 virtual/pkgconfig
129# This variable must be set before inheriting any eclasses. Defaults to 'never'. 325 !aqua? (
130OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 326 >=x11-libs/libXtst-1.1.0
327 x11-proto/xf86vidmodeproto
328 )
329"
131 330
132# @ECLASS-VARIABLE: WEBKIT_REQUIRED 331kderdepend=""
133# @DESCRIPTION:
134# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
135# This variable must be set before inheriting any eclasses. Defaults to 'never'.
136WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
137 332
138# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 333# all packages needs oxygen icons for basic iconset
139# @DESCRIPTION: 334if [[ ${PN} != oxygen-icons ]]; then
140# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 335 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
141# This variable must be set before inheriting any eclasses. Defaults to 'never'. 336fi
142CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
143 337
144case ${CPPUNIT_REQUIRED} in 338# add a dependency over kde-l10n if EAPI4 or better is around
339if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
340 for _lingua in ${KDE_LINGUAS}; do
341 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
342 # but only for selected ones.
343 # this can't be done on one line because if user doesn't use any localisation
344 # then he is probably not interested in kde-l10n at all.
345 kderdepend+="
346 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
347 "
348 done
349 unset _lingua
350fi
351
352kdehandbookdepend="
353 app-text/docbook-xml-dtd:4.2
354 app-text/docbook-xsl-stylesheets
355"
356kdehandbookrdepend="
357 $(add_kdebase_dep kdelibs 'handbook')
358"
359case ${KDE_HANDBOOK} in
145 always) 360 always)
146 DEPEND="${DEPEND} 361 kdedepend+=" ${kdehandbookdepend}"
147 dev-util/cppunit 362 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
148 "
149 ;; 363 ;;
150 optional) 364 optional)
151 IUSE="${IUSE} test" 365 IUSE+=" +handbook"
152 DEPEND="${DEPEND} 366 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
153 test? ( dev-util/cppunit ) 367 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
154 "
155 ;; 368 ;;
369 *) ;;
370esac
371unset kdehandbookdepend kdehandbookrdepend
372
373case ${KDE_SELINUX_MODULE} in
374 none) ;;
156 *) 375 *)
157 CPPUNIT_REQUIRED="never" 376 IUSE+=" selinux"
377 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
158 ;; 378 ;;
379esac
380
381case ${KDE_REQUIRED} in
382 always)
383 IUSE+=" aqua"
384 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
385 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
386 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
387 ;;
388 optional)
389 IUSE+=" aqua kde"
390 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
391 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
392 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
393 ;;
394 *) ;;
395esac
396
397unset kdecommondepend kdedepend kderdepend
398
399debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
400debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
401debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
402
403# Accumulate dependencies set by this eclass
404DEPEND+=" ${COMMONDEPEND}"
405RDEPEND+=" ${COMMONDEPEND}"
406unset COMMONDEPEND
407
408# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
409# kdevelop ebuild, the URI should be set in the ebuild itself
410_calculate_src_uri() {
411 debug-print-function ${FUNCNAME} "$@"
412
413 local _kmname _kmname_pv
414
415 # we calculate URI only for known KDEBASE modules
416 [[ -n ${KDEBASE} ]] || return
417
418 # calculate tarball module name
419 if [[ -n ${KMNAME} ]]; then
420 # fixup kdebase-apps name
421 case ${KMNAME} in
422 kdebase-apps)
423 _kmname="kdebase" ;;
424 *)
425 _kmname="${KMNAME}" ;;
159esac 426 esac
160 427 else
161# @ECLASS-VARIABLE: NEED_KDE 428 _kmname=${PN}
162# @DESCRIPTION: 429 fi
163# This variable sets the version of KDE4 which will be used by the eclass. 430 _kmname_pv="${_kmname}-${PV}"
164# For kde-base packages, if it is not set by the ebuild, 431 case ${KDEBASE} in
165# it's assumed that the required KDE4 version is the latest available. 432 kde-base)
166# For non kde-base packages, it is also set to the latest by default.
167#
168# For more precise adjustments or for specifying particular kde version,
169# KDE_MINIMAL variable can be used.
170#
171# @CODE
172# Acceptable values are:
173# - latest - Use latest version in the portage tree
174# Default for kde-base ebuilds.
175# - live - Use live release (live ebuilds)
176# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
177# - 4.2, 4.1, kde-4 - respective slots for kde versions
178# @CODE
179# Note: default NEED_KDE is latest
180NEED_KDE="${NEED_KDE:=latest}"
181export NEED_KDE
182
183# @ECLASS-VARIABLE: KDE_MINIMAL
184# @DESCRIPTION:
185# This wariable is used when NEED_KDE="latest" is set, to specify the
186# required KDE minimal version for which apps will work.
187# @CODE
188# KDE_MINIMAL="-4.1"
189# @CODE
190# Note: default minimal version is kde-4.1, which means that the apps will work
191# with any KDE version >=${KDE_MINIMAL}
192KDE_MINIMAL="${KDE_MINIMAL:=4.2}"
193export KDE_MINIMAL
194
195# FIXME: the code section, explanation of live. The last sentence needs other
196# formulation too.
197#
198# @ECLASS-VARIABLE: KDE_WANTED
199# @DESCRIPTION:
200# When NEED_KDE=latest is inherited, KDE_WANTED serves to indicate the prefered kde
201# version. It's value is looked for before any other. Useful when having more
202# +kdeprefix installs: you can choose which kde version, if present, to link
203# against.
204#
205# @CODE
206# Acceptable values are:
207# stable = whatever is main tree (now 4.1)
208# testing = whatever is in testing on main tree
209# snapshot = whatever is released under snapshots (4.2 at present)
210# live = live svn ebuilds, also default value, do not be scared it goes in this
211#
212# order: live->snapshot->testing->stable, when searching for kde. This way we
213# allow users to use just kde4snapshots and use software from the tree.
214KDE_WANTED="${KDE_WANTED:=live}"
215export KDE_WANTED
216
217case ${NEED_KDE} in
218 latest)
219 if [[ $KDEBASE = kde-base ]]; then
220 case ${PV} in 433 case ${PV} in
221 4.3* | 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) 434 4.4.11.1)
222 _kdedir="4.3" 435 # KDEPIM 4.4, special case
223 _pv="-${PV}:4.3" 436 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
224 _pvn="-${PV}" 437 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
438 4.[89].8[05] | 4.[89].9[0235678])
439 # Unstable KDE SC releases
440 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
441 4.[1234567].[12345])
442 # Stable KDE SC with old .bz2 support
443 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
444 *)
445 # Stable KDE SC releases
446 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
447 esac
225 ;; 448 ;;
226 4.2* | 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6*) 449 kdevelop|kdevelop-php*|kdevplatform)
227 _kdedir="4.2" 450 case ${KDEVELOP_VERSION} in
228 _pv="-${PV}:4.2" 451 4.[12].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
229 _pvn="-${PV}" 452 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
230 ;; 453 esac
231 4.1*| 4.0.9* | 4.0.8*)
232 _kdedir="4.1"
233 _pv="-${PV}:4.1"
234 _pvn="-${PV}"
235 ;;
236 4.0*)
237 _kdedir="4.0"
238 _pv="-${PV}:kde-4"
239 _pvn="-${PV}"
240 ;; 454 ;;
241 3.9*) 455 esac
242 _kdedir="3.9" 456}
243 _pv="-${PV}:kde-4" 457
244 _pvn="-${PV}" 458_calculate_live_repo() {
245 ;; 459 debug-print-function ${FUNCNAME} "$@"
460
461 SRC_URI=""
462 case ${KDE_SCM} in
463 svn)
464 # Determine branch URL based on live type
465 local branch_prefix
466 case ${PV} in
246 9999*) 467 9999*)
247 _kdedir="live" 468 # trunk
248 _pv="-${PV}:live" 469 branch_prefix="trunk/KDE"
249 _pvn="-${PV}"
250 ;; 470 ;;
251 *) 471 *)
252 die "NEED_KDE=latest not supported for PV=${PV}" ;; 472 # branch
253 esac 473 branch_prefix="branches/KDE/$(get_kde_version)"
254 _operator=">=" 474 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
255 else 475 # @DESCRIPTION
256 # this creates dependency on any version of kde4 476 # Suffix appended to ESVN_PROJECT depending on fetched branch.
257 _operator=">=" 477 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
258 _pv="-${KDE_MINIMAL}" 478 ESVN_PROJECT_SUFFIX="-${PV}"
259 _pvn=${_pv}
260 fi
261 ;;
262
263 # NEED_KDE="${PV}"
264 scm|svn|live|9999*)
265 _kdedir="live"
266 _operator=">="
267 _pv="-${NEED_KDE}:live"
268 _pvn="-${NEED_KDE}"
269 export NEED_KDE="live"
270 ;;
271 4.3 | 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*)
272 _kdedir="4.3"
273 _pv="-${NEED_KDE}:4.3"
274 _pvn="-${NEED_KDE}"
275 _operator=">="
276 ;;
277 4.2 | 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6*)
278 _kdedir="4.2"
279 _pv="-${NEED_KDE}:4.2"
280 _pvn="-${NEED_KDE}"
281 _operator=">="
282 ;;
283 4.1 | 4.0.9* | 4.0.8*)
284 _kdedir="4.1"
285 _pv="-${NEED_KDE}:4.1"
286 _pvn="-${NEED_KDE}"
287 _operator=">="
288 ;;
289 4.0* | 4)
290 _kdedir="4.0"
291 _operator=">="
292 _pv="-${NEED_KDE}:kde-4"
293 _pvn="-${NEED_KDE}"
294 ;;
295 3.9*)
296 _kdedir="3.9"
297 _operator=">="
298 _pv="-${NEED_KDE}:kde-4"
299 _pvn="-${NEED_KDE}"
300 ;;
301
302 # The ebuild handles dependencies, KDEDIR, SLOT.
303 none)
304 :
305 ;;
306
307 *)
308 die "NEED_KDE=${NEED_KDE} currently not supported."
309 ;;
310esac
311
312if [[ ${NEED_KDE} != none ]]; then
313 #Set the SLOT
314 if [[ -n ${KDEBASE} ]]; then
315 if [[ ${NEED_KDE} = live ]]; then
316 SLOT="live"
317 else
318 case ${KMNAME} in
319 koffice)
320 case ${PV} in
321 9999*) SLOT="live" ;;
322 *) SLOT="2" ;;
323 esac
324 ;;
325 kdevelop)
326 case ${PV} in
327 9999*) SLOT="live" ;;
328 4.0*|3.9*) SLOT="4" ;;
329 esac
330 ;;
331 kdevplatform)
332 case ${PV} in
333 9999*) SLOT="live" ;;
334 1.0*|0.9*) SLOT="1" ;;
335 esac
336 ;;
337 *)
338 case ${PV} in
339 9999*) SLOT="live" ;;
340 4.3* | 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) SLOT="4.3" ;;
341 4.2* | 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6*) SLOT="4.2" ;;
342 4.1* | 4.0.9* | 4.0.8*) SLOT="4.1" ;;
343 *) SLOT="4.1" ;;
344 esac
345 ;; 479 ;;
346 esac 480 esac
347 fi 481 # @ECLASS-VARIABLE: ESVN_MIRROR
348 fi 482 # @DESCRIPTION:
349 483 # This variable allows easy overriding of default kde mirror service
350 # Block installation of other SLOTS unless kdeprefix 484 # (anonsvn) with anything else you might want to use.
351 for KDE_SLOT in ${KDE_SLOTS[@]}; do
352 # block non kdeprefix ${PN} on other slots
353 # we do this only if we do not depend on any version of kde
354 if [[ ${SLOT} != ${KDE_SLOT} ]]; then
355 RDEPEND="${RDEPEND}
356 !kdeprefix? ( !kde-base/${PN}:${KDE_SLOT}[-kdeprefix] )
357 "
358 fi
359 done
360
361 # Adding kdelibs and kdebase-data deps to all other packages.
362 if [[ ${PN} != kdelibs ]]; then
363 DEPEND="${DEPEND}
364 kdeprefix? ( ${_operator}kde-base/kdelibs${_pv}[kdeprefix] )
365 !kdeprefix? ( ${_operator}kde-base/kdelibs${_pvn}[-kdeprefix] )
366 "
367 RDEPEND="${RDEPEND}
368 kdeprefix? ( ${_operator}kde-base/kdelibs${_pv}[kdeprefix] )
369 !kdeprefix? ( ${_operator}kde-base/kdelibs${_pvn}[-kdeprefix] )
370 "
371 if [[ ${PN} != kdepimlibs && ${PN} != kdebase-data ]]; then
372 RDEPEND="${RDEPEND}
373 kdeprefix? ( ${_operator}kde-base/kdebase-data${_pv}[kdeprefix] )
374 !kdeprefix? ( ${_operator}kde-base/kdebase-data${_pvn}[-kdeprefix] )
375 "
376 fi
377 fi
378 unset _operator _pv _pvn
379fi
380
381# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
382# koffice ebuild, the URI should be set in the ebuild itself
383case ${BUILD_TYPE} in
384 live)
385 SRC_URI=""
386 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde} 485 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
387 # Split ebuild, or extragear stuff 486 # Split ebuild, or extragear stuff
388 if [[ -n ${KMNAME} ]]; then 487 if [[ -n ${KMNAME} ]]; then
389 ESVN_PROJECT="${KMNAME}" 488 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
390 if [[ -z ${KMNOMODULE} && -z ${KMMODULE} ]]; then 489 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
391 KMMODULE="${PN}" 490 KMMODULE="${PN}"
491 fi
492 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
493 case ${KMNAME} in
494 kdebase-*)
495 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
496 ;;
497 kdelibs-*)
498 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
499 ;;
500 kdereview*)
501 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
502 ;;
503 kdesupport)
504 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
505 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
506 ;;
507 kde*)
508 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
509 ;;
510 extragear*|playground*)
511 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
512 # build packages from same svn location.
513 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
514 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
515 ;;
516 *)
517 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
518 ;;
519 esac
520 else
521 # kdelibs, kdepimlibs
522 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
523 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
392 fi 524 fi
393 # Split kde-base/ ebuilds: (they reside in trunk/KDE) 525 # @ECLASS-VARIABLE: ESVN_UP_FREQ
394 case ${KMNAME} in 526 # @DESCRIPTION:
395 kdebase-*) 527 # This variable is used for specifying the timeout between svn synces
396 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/KDE/kdebase/${KMNAME#kdebase-}" 528 # for kde-base modules. Does not affect misc apps.
397 ;; 529 # Default value is 1 hour.
398 kdereview) 530 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
399 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
400 ;;
401 kde*)
402 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/KDE/${KMNAME}"
403 ;;
404 extragear*|playground*)
405 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
406 ;;
407 koffice)
408 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
409 ;;
410 *)
411 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
412 ;;
413 esac
414 else
415 # kdelibs, kdepimlibs
416 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/KDE/${PN}"
417 ESVN_PROJECT="${PN}"
418 fi
419 # limit syncing to 1 hour.
420 ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
421 ;; 531 ;;
422 *) 532 git)
533 local _kmname
534 # @ECLASS-VARIABLE: EGIT_MIRROR
535 # @DESCRIPTION:
536 # This variable allows easy overriding of default kde mirror service
537 # (anongit) with anything else you might want to use.
538 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
539
540 # @ECLASS-VARIABLE: EGIT_REPONAME
541 # @DESCRIPTION:
542 # This variable allows overriding of default repository
543 # name. Specify only if this differ from PN and KMNAME.
423 if [[ -n ${KDEBASE} ]]; then 544 if [[ -n ${EGIT_REPONAME} ]]; then
545 # the repository and kmname different
546 _kmname=${EGIT_REPONAME}
424 if [[ -n ${KMNAME} ]]; then 547 elif [[ -n ${KMNAME} ]]; then
425 case ${KMNAME} in
426 kdebase-apps)
427 _kmname="kdebase" ;;
428 *)
429 _kmname=${KMNAME} ;; 548 _kmname=${KMNAME}
430 esac
431 else 549 else
432 _kmname=${PN} 550 _kmname=${PN}
433 fi 551 fi
434 _kmname_pv="${_kmname}-${PV}" 552
435 if [[ $NEED_KDE != live ]]; then 553 # default branching
436 case ${KDEBASE} in 554 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
437 kde-base) 555 EGIT_BRANCH="KDE/$(get_kde_version)"
438 case ${PV} in 556
439 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) 557 # default repo uri
440 SRC_URI="http://dev.gentooexperimental.org/~alexxy/kde/${PV}/${_kmname_pv}.tar.lzma" ;; 558 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
441 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6* | 4.0.9* | 4.0.8*) 559
442 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 560 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
443 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 561 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
444 esac
445 ;;
446 koffice)
447 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2"
448 ;; 562 ;;
449 esac 563 esac
564}
565
566case ${KDE_BUILD_TYPE} in
567 live) _calculate_live_repo ;;
568 *) _calculate_src_uri ;;
569esac
570
571debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
572
573# @ECLASS-VARIABLE: PREFIX
574# @DESCRIPTION:
575# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
576# kde-base packages go into KDE4 installation directory (/usr).
577# No matter the PREFIX, package will be built against KDE installed in /usr.
578
579# @FUNCTION: kde4-base_pkg_setup
580# @DESCRIPTION:
581# Do some basic settings
582kde4-base_pkg_setup() {
583 debug-print-function ${FUNCNAME} "$@"
584
585 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
586 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
587 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
450 fi 588 fi
451 unset _kmname _kmname_pv 589
590 # Don't set KDEHOME during compilation, it will cause access violations
591 unset KDEHOME
592
593 # Check if gcc compiler is fresh enough.
594 # In theory should be in pkg_pretend but we check it only for kdelibs there
595 # and for others we do just quick scan in pkg_setup because pkg_pretend
596 # executions consume quite some time.
597 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
598 # is otherwise undefined.
599 if [[ ${EAPI:-0} != 3 ]]; then
600 if [[ ${MERGE_TYPE} != binary ]]; then
601 [[ $(gcc-major-version) -lt 4 ]] || \
602 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
603 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
452 fi 604 fi
453 ;; 605 fi
454esac
455 606
456debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
457
458# @ECLASS-VARIABLE: PREFIX
459# @DESCRIPTION:
460# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
461# Applications installed by the other ebuilds go into ${KDEDIR} by default, this value
462# can be superseded by defining PREFIX before inheriting kde4-base.
463# This value is set on pkg_setup
464PREFIX=""
465
466debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - NEED_KDE ${NEED_KDE}"
467
468# @FUNCTION: kde4-base_pkg_setup
469# @DESCRIPTION:
470# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
471# kde4-functions_check_use from kde4-functions.eclass to print appropriate
472# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
473# $KDE4_BUILT_WITH_USE_CHECK are missing.
474kde4-base_pkg_setup() {
475 debug-print-function ${FUNCNAME} "$@"
476
477 # Don't set KDEHOME during compile, it will cause access violations
478 unset KDEHOME
479
480 # Search for best suitable kde installation for misc kde package.
481 # Computation based on NEED_KDE and KDE_MINIMAL
482 [[ ${KDEBASE} != kde-base ]] && [[ ${NEED_KDE} = latest || ${NEED_KDE} = none ]] && get_latest_kdedir
483
484 # Set PREFIX
485 if use kdeprefix; then
486 KDEDIR="/usr/kde/${_kdedir}"
487 KDEDIRS="/usr/local/:/usr:${KDEDIR}"
488 else
489 KDEDIR="/usr" 607 KDEDIR=/usr
490 KDEDIRS="/usr/local/:/usr" 608 : ${PREFIX:=/usr}
491 fi 609 EKDEDIR=${EPREFIX}/usr
492 # Set the prefix based on KDEDIR
493 # Make it a consequence of kdeprefix
494 PREFIX=${KDEDIR}
495 610
496 unset _kdedir 611 # Point to correct QT plugins path
612 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
497 613
498 # check if qt has correct deps 614 # Fix XDG collision with sandbox
499 [[ -n ${QT4_BUILT_WITH_USE_CHECK} || -n ${KDE4_BUILT_WITH_USE_CHECK[@]} ]] && \ 615 export XDG_CONFIG_HOME="${T}"
500 die "built_with_use illegal in this EAPI!"
501
502 if [[ ${BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
503 echo
504 elog "WARNING! This is an experimental live ebuild of ${KMNAME:-${PN}}"
505 elog "Use it at your own risk."
506 elog "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
507 echo
508 fi
509} 616}
510 617
511# @FUNCTION: kde4-base_src_unpack 618# @FUNCTION: kde4-base_src_unpack
512# @DESCRIPTION: 619# @DESCRIPTION:
513# This function unpacks the source tarballs for KDE4 applications. 620# This function unpacks the source tarballs for KDE4 applications.
514kde4-base_src_unpack() { 621kde4-base_src_unpack() {
515 debug-print-function ${FUNCNAME} "$@" 622 debug-print-function ${FUNCNAME} "$@"
516 623
517 if [[ ${BUILD_TYPE} = live ]]; then 624 if [[ ${KDE_BUILD_TYPE} = live ]]; then
625 case ${KDE_SCM} in
626 svn)
518 migrate_store_dir 627 migrate_store_dir
519 subversion_src_unpack 628 subversion_src_unpack
629 ;;
630 git)
631 git-2_src_unpack
632 ;;
633 esac
520 else 634 else
521 base_src_unpack 635 unpack ${A}
522 fi 636 fi
523} 637}
524 638
525# @FUNCTION: kde4-base_src_compile 639# @FUNCTION: kde4-base_src_prepare
526# @DESCRIPTION: 640# @DESCRIPTION:
527# General pre-configure and pre-compile function for KDE4 applications. 641# General pre-configure and pre-compile function for KDE4 applications.
528# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 642# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
643# enable_selected_linguas() and enable_selected_doc_linguas()
529# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 644# in kde4-functions.eclass(5) for further details.
530kde4-base_src_prepare() { 645kde4-base_src_prepare() {
531 debug-print-function ${FUNCNAME} "$@" 646 debug-print-function ${FUNCNAME} "$@"
647
648 # enable handbook and linguas only when not using live ebuild
532 649
533 # Only enable selected languages, used for KDE extragear apps. 650 # Only enable selected languages, used for KDE extragear apps.
534 if [[ -n ${KDE_LINGUAS} ]]; then 651 if [[ -n ${KDE_LINGUAS} ]]; then
535 enable_selected_linguas 652 enable_selected_linguas
536 fi 653 fi
537 654
655 # Enable/disable handbooks for kde4-base packages
656 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
657 # kdelibs inherits kde4-base but handle installing the handbook itself
658 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
659 if [[ ${KDEBASE} == kde-base ]]; then
660 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
661 # documentation in kde4-functions
662 : ${KDE_DOC_DIRS:=doc}
663 local dir
664 for dir in ${KDE_DOC_DIRS}; do
665 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
666 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
667 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
668 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
669 -i CMakeLists.txt || die "failed to comment out handbook"
670 done
671 fi
672 else
673 enable_selected_doc_linguas
674 fi
675 fi
676
677 # SCM bootstrap
678 if [[ ${KDE_BUILD_TYPE} = live ]]; then
679 case ${KDE_SCM} in
680 svn) subversion_src_prepare ;;
681 esac
682 fi
683
684 # Apply patches
538 base_src_prepare 685 base_src_prepare
539 686
540 # Save library dependencies 687 # Save library dependencies
541 if [[ -n ${KMSAVELIBS} ]] ; then 688 if [[ -n ${KMSAVELIBS} ]] ; then
542 save_library_dependencies 689 save_library_dependencies
544 691
545 # Inject library dependencies 692 # Inject library dependencies
546 if [[ -n ${KMLOADLIBS} ]] ; then 693 if [[ -n ${KMLOADLIBS} ]] ; then
547 load_library_dependencies 694 load_library_dependencies
548 fi 695 fi
696
697 # Hack for manuals relying on outdated DTD, only outside kde-base/...
698 if [[ -z ${KDEBASE} ]]; then
699 find "${S}" -name "*.docbook" \
700 -exec sed -i -r \
701 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
702 || die 'failed to fix DocBook variant version'
703 fi
549} 704}
550 705
551# @FUNCTION: kde4-base_src_configure 706# @FUNCTION: kde4-base_src_configure
552# @DESCRIPTION: 707# @DESCRIPTION:
553# Function for configuring the build of KDE4 applications. 708# Function for configuring the build of KDE4 applications.
554kde4-base_src_configure() { 709kde4-base_src_configure() {
555 debug-print-function ${FUNCNAME} "$@" 710 debug-print-function ${FUNCNAME} "$@"
556 711
712 # Build tests in src_test only, where we override this value
713 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
714
715 if use_if_iuse debug; then
716 # Set "real" debug mode
717 CMAKE_KDE_BUILD_TYPE="Debugfull"
718 else
557 # Handle common release builds 719 # Handle common release builds
558 if ! has debug ${IUSE//+} || ! use debug; then
559 append-cppflags -DQT_NO_DEBUG 720 append-cppflags -DQT_NO_DEBUG
560 fi 721 fi
561 722
562 # Enable generation of HTML handbook
563 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
564 ebegin "Enabling building of HTML handbook"
565 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
566 eend $?
567 fi
568
569 # Build tests in src_test only, where we override this value
570 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
571
572 # Set distribution name 723 # Set distribution name
573 [[ ${PN} = kdelibs ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo" 724 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
574
575 # runpath linking
576 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
577 725
578 # Here we set the install prefix 726 # Here we set the install prefix
579 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}" 727 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
580 728
581 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 729 # Use colors
582 use kdeprefix || mycmakeargs="${mycmakeargs} -DSYSCONF_INSTALL_DIR=/etc"
583
584 # Set environment
585 QTEST_COLORED=1 730 QTEST_COLORED=1
586 QT_PLUGIN_PATH="${KDEDIR}/$(get_libdir)/kde4/plugins/"
587 731
588 # Hardcode path to *.pc KDE files 732 # Shadow existing installations
589 export PKG_CONFIG_PATH="${PKG_CONFIG_PATH:+${PKG_CONFIG_PATH}:}${KDEDIR}/$(get_libdir)/pkgconfig" 733 unset KDEDIRS
590 734
591 # Override some environment variables 735 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
592 PATH="${KDEDIR}/bin:${PATH}" 736 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
593 LDPATH="${KDEDIR}/$(get_libdir):${LDPATH}" 737 #kde-config -path data unavailable when cross-compiling
738 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
594 739
595 # Set cmake prefixes to allow buildsystem to localize valid KDE installation when more are present 740 # sysconf needs to be /etc, not /usr/etc
596 if use kdeprefix; then 741 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
742
743 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
744 if [[ ${mycmakeargs} ]]; then
745 eqawarn "mycmakeargs should always be declared as an array, not a string"
746 fi
597 mycmakeargs="${mycmakeargs} 747 mycmakeargs=(${mycmakeargs})
598 -DCMAKE_SYSTEM_INCLUDE_PATH=${KDEDIR}/include
599 -DCMAKE_SYSTEM_LIBRARY_PATH=${KDEDIR}/$(get_libdir)
600 -DCMAKE_SYSTEM_PREFIX_PATH=${KDEDIR}
601 -DCMAKE_SYSTEM_PROGRAM_PATH=${KDEDIR}/bin"
602 fi 748 fi
603 749
604 [ -e CMakeLists.txt ] && cmake-utils_src_configure 750 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
751
752 cmake-utils_src_configure
605} 753}
606 754
607# @FUNCTION: kde4-base_src_compile 755# @FUNCTION: kde4-base_src_compile
608# @DESCRIPTION: 756# @DESCRIPTION:
609# General function for compiling KDE4 applications. 757# General function for compiling KDE4 applications.
610kde4-base_src_compile() { 758kde4-base_src_compile() {
611 debug-print-function ${FUNCNAME} "$@" 759 debug-print-function ${FUNCNAME} "$@"
612 760
613 cmake-utils_src_compile 761 cmake-utils_src_compile "$@"
614} 762}
615 763
616# @FUNCTION: kde4-base_src_test 764# @FUNCTION: kde4-base_src_test
617# @DESCRIPTION: 765# @DESCRIPTION:
618# Function for testing KDE4 applications. 766# Function for testing KDE4 applications.
619kde4-base_src_test() { 767kde4-base_src_test() {
620 debug-print-function ${FUNCNAME} "$@" 768 debug-print-function ${FUNCNAME} "$@"
621 769
770 local kded4_pid
771
772 _test_runner() {
773 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
774 export $(dbus-launch)
775 kded4 2>&1 > /dev/null &
776 kded4_pid=$!
777 fi
778
779 cmake-utils_src_test
780 }
781
782 # When run as normal user during ebuild development with the ebuild command, the
783 # kde tests tend to access the session DBUS. This however is not possible in a real
784 # emerge or on the tinderbox.
785 # > make sure it does not happen, so bad tests can be recognized and disabled
786 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
787
622 # Override this value, set in kde4-base_src_configure() 788 # Override this value, set in kde4-base_src_configure()
623 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 789 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
624 cmake-utils_src_configure 790 cmake-utils_src_configure
625 kde4-base_src_compile 791 kde4-base_src_compile
626 792
627 cmake-utils_src_test 793 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
794 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
795 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
796 # surprise- we are already INSIDE virtualmake!!!
797 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
798 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
799 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
800 debug-print " kde4-base.eclass docs for details... Applying workaround."
801 _test_runner
802 else
803 VIRTUALX_COMMAND="_test_runner" virtualmake
804 fi
805 else
806 _test_runner
807 fi
808
809 if [ -n "${kded4_pid}" ] ; then
810 kill ${kded4_pid}
811 fi
812
813 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
814 kill ${DBUS_SESSION_BUS_PID}
815 fi
628} 816}
629 817
630# @FUNCTION: kde4-base_src_install 818# @FUNCTION: kde4-base_src_install
631# @DESCRIPTION: 819# @DESCRIPTION:
632# Function for installing KDE4 applications. 820# Function for installing KDE4 applications.
635 823
636 if [[ -n ${KMSAVELIBS} ]] ; then 824 if [[ -n ${KMSAVELIBS} ]] ; then
637 install_library_dependencies 825 install_library_dependencies
638 fi 826 fi
639 827
640 kde4-base_src_make_doc 828 # Install common documentation of KDE4 applications
829 local doc
830 if ! has kde4-meta ${INHERITED}; then
831 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
832 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
833 done
834 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
835 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
836 done
837 fi
838
641 cmake-utils_src_install 839 cmake-utils_src_install
642}
643 840
644# @FUNCTION: kde4-base_src_make_doc 841 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
645# @DESCRIPTION: 842 # because then khelpcenter can't find the docs
646# Function for installing the documentation of KDE4 applications. 843 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
647kde4-base_src_make_doc() { 844 docompress -x ${PREFIX}/share/doc/HTML
648 debug-print-function ${FUNCNAME} "$@" 845}
649 846
650 local doc 847# @FUNCTION: kde4-base_pkg_preinst
651 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 848# @DESCRIPTION:
652 [[ -s ${doc} ]] && dodoc ${doc} 849# Function storing icon caches
653 done 850kde4-base_pkg_preinst() {
851 debug-print-function ${FUNCNAME} "$@"
654 852
655 if [[ -z ${KMNAME} ]]; then 853 gnome2_icon_savelist
656 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 854 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
657 if [[ -s ${doc} ]]; then 855 subversion_pkg_preinst
658 local doc_complete=${doc}
659 doc="${doc#*/}"
660 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
661 fi
662 done
663 fi
664
665 if [[ -n ${KDEBASE} && -d "${D}/usr/share/doc/${PF}" ]]; then
666 # work around bug #97196
667 dodir /usr/share/doc/kde && \
668 mv "${D}/usr/share/doc/${PF}" "${D}"/usr/share/doc/kde/ || \
669 die "Failed to move docs to kde/ failed."
670 fi 856 fi
671} 857}
672 858
673# @FUNCTION: kde4-base_pkg_postinst 859# @FUNCTION: kde4-base_pkg_postinst
674# @DESCRIPTION: 860# @DESCRIPTION:
675# Function to rebuild the KDE System Configuration Cache after an application has been installed. 861# Function to rebuild the KDE System Configuration Cache after an application has been installed.
676kde4-base_pkg_postinst() { 862kde4-base_pkg_postinst() {
677 debug-print-function ${FUNCNAME} "$@" 863 debug-print-function ${FUNCNAME} "$@"
678 864
865 gnome2_icon_cache_update
866 fdo-mime_desktop_database_update
867 fdo-mime_mime_database_update
679 buildsycoca 868 buildsycoca
869
870 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
871 if [[ ${KDE_BUILD_TYPE} = live ]]; then
872 echo
873 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
874 einfo "Use it at your own risk."
875 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
876 echo
877 fi
878 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
879 if [[ ${KDEBASE} != kde-base ]] && \
880 ! has_version 'kde-base/kdebase-runtime-meta' && \
881 ! has_version 'kde-base/kdebase-startkde'; then
882 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
883 echo
884 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
885 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
886 ewarn "With this setting you are unsupported by KDE team."
887 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
888 fi
889 fi
890 fi
680} 891}
681 892
682# @FUNCTION: kde4-base_pkg_postrm 893# @FUNCTION: kde4-base_pkg_postrm
683# @DESCRIPTION: 894# @DESCRIPTION:
684# Function to rebuild the KDE System Configuration Cache after an application has been removed. 895# Function to rebuild the KDE System Configuration Cache after an application has been removed.
685kde4-base_pkg_postrm() { 896kde4-base_pkg_postrm() {
686 debug-print-function ${FUNCNAME} "$@" 897 debug-print-function ${FUNCNAME} "$@"
687 898
899 gnome2_icon_cache_update
900 fdo-mime_desktop_database_update
901 fdo-mime_mime_database_update
688 buildsycoca 902 buildsycoca
689} 903}

Legend:
Removed from v.1.32  
changed lines
  Added in v.1.122

  ViewVC Help
Powered by ViewVC 1.1.20